<?php
/**
 * Admin Menu: Orijinal Silme
 * 
 * Bu dosya, Auto WebP Converter eklentisinin Orijinal Silme sayfasını içerir.
 */

// Doğrudan erişimi engelle
if (!defined('ABSPATH')) {
    exit;
}

/**
 * Orijinal Silme sayfası sınıfı
 */
class AWC_Original_Delete_Page {
    
    /**
     * Sayfa başlatma
     */
    public static function init() {
        add_action('admin_menu', array(__CLASS__, 'add_menu_page'), 40);
    }
    
    /**
     * Menü sayfasını ekler
     */
    public static function add_menu_page() {
        add_submenu_page(
            'advanced-image-management',
            __('Orijinal Silme', 'advanced-image-management'),
            __('Orijinal Silme', 'advanced-image-management'),
            'manage_options',
            'advanced-image-management-delete',
            array(__CLASS__, 'render_page')
        );
    }
    
    /**
     * Sayfayı render eder
     */
    public static function render_page() {
        ?>
        <div class="wrap">
            <h1><?php esc_html_e('Orijinal Silme', 'advanced-image-management'); ?></h1>
            <div class="awc-original-delete">
                <div class="awc-section">
                    <h2><?php esc_html_e('Orijinal Resimleri Silme', 'advanced-image-management'); ?></h2>
                    <p><?php esc_html_e('WebP dönüşümü yapılmış resimlerin orijinallerini silin. Bu işlem geri alınamaz!', 'advanced-image-management'); ?></p>
                    <div class="awc-warning">
                        <p><strong><?php esc_html_e('Uyarı', 'advanced-image-management'); ?>:</strong> <?php esc_html_e('Bu işlem, WebP dönüşümü yapılmış resimlerin orijinallerini kalıcı olarak siler. Bu işlem geri alınamaz!', 'advanced-image-management'); ?></p>
                    </div>
                    <button type="button" class="button button-primary" id="awc-delete-original-images"><?php esc_html_e('Orijinal Resimleri Sil', 'advanced-image-management'); ?></button>
                    <div id="awc-delete-progress" style="display: none;">
                        <div class="awc-progress-bar">
                            <div class="awc-progress-bar-inner"></div>
                        </div>
                        <div class="awc-progress-text">0%</div>
                    </div>
                </div>
                
                <div class="awc-section">
                    <h2><?php esc_html_e('Resim Boyutlarını Silme', 'advanced-image-management'); ?></h2>
                    <p><?php esc_html_e('WordPress\'in oluşturduğu farklı boyutlardaki resimleri silin. Bu işlem geri alınamaz!', 'advanced-image-management'); ?></p>
                    <div class="awc-warning">
                        <p><strong><?php esc_html_e('Uyarı', 'advanced-image-management'); ?>:</strong> <?php esc_html_e('Bu işlem, WordPress\'in oluşturduğu farklı boyutlardaki resimleri kalıcı olarak siler. Bu işlem geri alınamaz!', 'advanced-image-management'); ?></p>
                    </div>
                    <button type="button" class="button button-primary" id="awc-delete-image-sizes"><?php esc_html_e('Resim Boyutlarını Sil', 'advanced-image-management'); ?></button>
                    <div id="awc-delete-sizes-progress" style="display: none;">
                        <div class="awc-progress-bar">
                            <div class="awc-progress-bar-inner"></div>
                        </div>
                        <div class="awc-progress-text">0%</div>
                    </div>
                </div>
                
                <div class="awc-section">
                    <h2><?php esc_html_e('Detaylı Varyasyon Yönetimi', 'advanced-image-management'); ?></h2>
                    <p><?php esc_html_e('Daha detaylı varyasyon yönetimi ve seçimli silme işlemleri için Medya Yönetimi sayfasını kullanabilirsiniz.', 'advanced-image-management'); ?></p>
                    <a href="<?php echo admin_url('admin.php?page=advanced-image-management-media'); ?>" class="button"><?php esc_html_e('Medya Yönetimi Sayfasına Git', 'advanced-image-management'); ?></a>
                </div>
            </div>
        </div>
        <script>
            jQuery(document).ready(function($) {
                $('#awc-delete-original-images').on('click', function() {
                    if (confirm('<?php esc_html_e('Bu işlem, WebP dönüşümü yapılmış resimlerin orijinallerini kalıcı olarak siler. Bu işlem geri alınamaz! Devam etmek istediğinize emin misiniz?', 'advanced-image-management'); ?>')) {
                        var button = $(this);
                        button.prop('disabled', true);
                        
                        $('#awc-delete-progress').show();
                        $('.awc-progress-bar-inner').css('width', '0%');
                        $('.awc-progress-text').text('0%');
                        
                        var data = {
                            action: 'awc_delete_original_images',
                            nonce: '<?php echo wp_create_nonce('awc_delete_original_images'); ?>'
                        };
                        
                        $.post(ajaxurl, data, function(response) {
                            if (response.success) {
                                $('.awc-progress-bar-inner').css('width', '100%');
                                $('.awc-progress-text').text('100%');
                                alert('<?php esc_html_e('Orijinal resimler başarıyla silindi!', 'advanced-image-management'); ?> ' + response.data.deleted_count + ' <?php esc_html_e('dosya silindi, toplam', 'advanced-image-management'); ?> ' + response.data.saved_size + ' <?php esc_html_e('alan kazanıldı.', 'advanced-image-management'); ?>');
                            } else {
                                $('.awc-progress-bar-inner').css('width', '0%');
                                $('.awc-progress-text').text('0%');
                                alert('<?php esc_html_e('Orijinal resimler silinirken bir hata oluştu!', 'advanced-image-management'); ?>' + (response.data && response.data.error ? '\n\n' + response.data.error : ''));
                            }
                            
                            button.prop('disabled', false);
                        }).fail(function(xhr, status, error) {
                            $('.awc-progress-bar-inner').css('width', '0%');
                            $('.awc-progress-text').text('0%');
                            alert('<?php esc_html_e('Orijinal resimler silinirken bir hata oluştu!', 'advanced-image-management'); ?> ' + error);
                            button.prop('disabled', false);
                        });
                    }
                });
                
                $('#awc-delete-image-sizes').on('click', function() {
                    if (confirm('<?php esc_html_e('Bu işlem, WordPress\'in oluşturduğu farklı boyutlardaki resimleri kalıcı olarak siler. Bu işlem geri alınamaz! Devam etmek istediğinize emin misiniz?', 'advanced-image-management'); ?>')) {
                        var button = $(this);
                        button.prop('disabled', true);
                        
                        $('#awc-delete-sizes-progress').show();
                        $('.awc-progress-bar-inner').css('width', '0%');
                        $('.awc-progress-text').text('0%');
                        
                        var data = {
                            action: 'awc_delete_image_sizes',
                            nonce: '<?php echo wp_create_nonce('awc_delete_image_sizes'); ?>'
                        };
                        
                        $.post(ajaxurl, data, function(response) {
                            if (response.success) {
                                $('.awc-progress-bar-inner').css('width', '100%');
                                $('.awc-progress-text').text('100%');
                                alert('<?php esc_html_e('Resim boyutları başarıyla silindi!', 'advanced-image-management'); ?> ' + response.data.deleted_count + ' <?php esc_html_e('dosya silindi, toplam', 'advanced-image-management'); ?> ' + response.data.saved_size + ' <?php esc_html_e('alan kazanıldı.', 'advanced-image-management'); ?>');
                            } else {
                                $('.awc-progress-bar-inner').css('width', '0%');
                                $('.awc-progress-text').text('0%');
                                alert('<?php esc_html_e('Resim boyutları silinirken bir hata oluştu!', 'advanced-image-management'); ?>');
                            }
                            
                            button.prop('disabled', false);
                        }).fail(function(xhr, status, error) {
                            $('.awc-progress-bar-inner').css('width', '0%');
                            $('.awc-progress-text').text('0%');
                            alert('<?php esc_html_e('Resim boyutları silinirken bir hata oluştu!', 'advanced-image-management'); ?> ' + error);
                            button.prop('disabled', false);
                        });
                    }
                });
            });
        </script>
        <style>
            .awc-section {
                margin-bottom: 30px;
                padding: 20px;
                background-color: #fff;
                border: 1px solid #ccc;
                border-radius: 3px;
            }
            
            .awc-warning {
                margin-bottom: 20px;
                padding: 10px;
                background-color: #f9d4d4;
                border: 1px solid #f9a8a8;
                border-radius: 3px;
            }
            
            .awc-progress-bar {
                width: 100%;
                height: 20px;
                background-color: #f0f0f0;
                border-radius: 3px;
                margin-top: 10px;
            }
            
            .awc-progress-bar-inner {
                width: 0;
                height: 100%;
                background-color: #0073aa;
                border-radius: 3px;
                transition: width 0.3s;
            }
            
            .awc-progress-text {
                margin-top: 5px;
                font-weight: bold;
            }
        </style>
        <?php
    }
}

// Sayfayı başlat
AWC_Original_Delete_Page::init();
