<?php
/**
 * Admin Menu: Eski Resimleri Yeniden Boyutlandırma
 * 
 * Bu dosya, Auto WebP Converter eklentisinin Eski Resimleri Yeniden Boyutlandırma sayfasını içerir.
 */

// Doğrudan erişimi engelle
if (!defined('ABSPATH')) {
    exit;
}

/**
 * Eski Resimleri Yeniden Boyutlandırma sayfası sınıfı
 */
class AWC_Resize_Old_Images_Page {
    
    /**
     * Sayfa başlatma
     */
    public static function init() {
        add_action('admin_menu', array(__CLASS__, 'add_menu_page'), 40);
    }
    
    /**
     * Menü sayfasını ekler
     */
    public static function add_menu_page() {
        add_submenu_page(
            'advanced-image-management',
            __('Eski Resimleri Yeniden Boyutlandırma', 'advanced-image-management'),
            __('Yeniden Boyutlandırma', 'advanced-image-management'),
            'manage_options',
            'advanced-image-management-resize',
            array(__CLASS__, 'render_page')
        );
    }
    
    /**
     * Sayfayı render eder
     */
    public static function render_page() {
        ?>
        <div class="wrap">
            <h1><?php esc_html_e('Eski Resimleri Yeniden Boyutlandırma', 'advanced-image-management'); ?></h1>
            
            <div class="awc-section">
                <h2><?php esc_html_e('Yeniden Boyutlandırma Ayarları', 'advanced-image-management'); ?></h2>
                <p><?php esc_html_e('Eski resimleri yeniden boyutlandırmak için aşağıdaki ayarları yapın.', 'advanced-image-management'); ?></p>
                
                <form id="awc-resize-settings-form">
                    <table class="form-table">
                        <tr>
                            <th scope="row"><?php esc_html_e('Resim Kalitesi', 'advanced-image-management'); ?></th>
                            <td>
                                <input type="number" id="awc-resize-quality" name="quality" min="1" max="100" value="90" class="small-text">
                                <p class="description"><?php esc_html_e('1-100 arası kalite değeri (90 önerilir)', 'advanced-image-management'); ?></p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row"><?php esc_html_e('Yeni Genişlik', 'advanced-image-management'); ?></th>
                            <td>
                                <input type="number" id="awc-resize-width" name="width" min="0" value="1920" class="small-text">
                                <p class="description"><?php esc_html_e('Piksel cinsinden genişlik (0 = orijinal genişliği koru)', 'advanced-image-management'); ?></p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row"><?php esc_html_e('Yeni Yükseklik', 'advanced-image-management'); ?></th>
                            <td>
                                <input type="number" id="awc-resize-height" name="height" min="0" value="0" class="small-text">
                                <p class="description"><?php esc_html_e('Piksel cinsinden yükseklik (0 = orijinal yüksekliği koru)', 'advanced-image-management'); ?></p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row"><?php esc_html_e('Orijinalleri Yedekle', 'advanced-image-management'); ?></th>
                            <td>
                                <label>
                                    <input type="checkbox" id="awc-keep-originals" name="keep_originals" value="1">
                                    <?php esc_html_e('Orijinal resimleri yedekle (dosya adına _backup eki ekler)', 'advanced-image-management'); ?>
                                </label>
                            </td>
                        </tr>
                    </table>
                </form>
            </div>
            
            <div class="awc-section">
                <h2><?php esc_html_e('Klasör Seçimi', 'advanced-image-management'); ?></h2>
                <p><?php esc_html_e('Yeniden boyutlandırmak istediğiniz resimlerin bulunduğu klasörleri seçin.', 'advanced-image-management'); ?></p>
                
                <button type="button" class="button" id="awc-load-folders"><?php esc_html_e('Klasörleri Yükle', 'advanced-image-management'); ?></button>
                
                <div id="awc-folder-structure" style="display: none; margin-top: 20px;">
                    <div id="awc-folder-tree"></div>
                    
                    <div class="awc-folder-actions" style="margin-top: 15px;">
                        <button type="button" class="button" id="awc-select-all-folders"><?php esc_html_e('Tümünü Seç', 'advanced-image-management'); ?></button>
                        <button type="button" class="button" id="awc-deselect-all-folders"><?php esc_html_e('Tümünü Kaldır', 'advanced-image-management'); ?></button>
                        <button type="button" class="button" id="awc-analyze-selected-folders"><?php esc_html_e('Seçili Klasörleri Analiz Et', 'advanced-image-management'); ?></button>
                    </div>
                </div>
                
                <div id="awc-folder-analysis" style="display: none; margin-top: 20px;">
                    <h3><?php esc_html_e('Klasör Analizi', 'advanced-image-management'); ?></h3>
                    <div id="awc-folder-analysis-results"></div>
                </div>
            </div>
            
            <div class="awc-section">
                <h2><?php esc_html_e('Yeniden Boyutlandırma İşlemi', 'advanced-image-management'); ?></h2>
                <p><?php esc_html_e('Seçilen klasörlerdeki resimleri yeniden boyutlandırmak için aşağıdaki butona tıklayın.', 'advanced-image-management'); ?></p>
                
                <button type="button" class="button button-primary" id="awc-start-resize"><?php esc_html_e('Yeniden Boyutlandırmayı Başlat', 'advanced-image-management'); ?></button>
                
                <div id="awc-resize-progress" style="display: none; margin-top: 20px;">
                    <div class="awc-progress-info">
                        <span id="awc-resize-current-file"></span>
                        <span id="awc-resize-count" style="float: right;"></span>
                    </div>
                    <div class="awc-progress-bar">
                        <div class="awc-progress-bar-inner"></div>
                    </div>
                    <div class="awc-progress-text">0%</div>
                </div>
                
                <div id="awc-resize-results" style="display: none; margin-top: 20px;">
                    <h3><?php esc_html_e('İşlem Sonuçları', 'advanced-image-management'); ?></h3>
                    <div id="awc-resize-summary"></div>
                </div>
            </div>
        </div>
        
        <script>
            jQuery(document).ready(function($) {
                // Klasörleri yükle
                $('#awc-load-folders').on('click', function() {
                    var button = $(this);
                    button.prop('disabled', true);
                    
                    var data = {
                        action: 'awc_get_upload_folders',
                        nonce: '<?php echo wp_create_nonce('awc_get_upload_folders'); ?>'
                    };
                    
                    $.post(ajaxurl, data, function(response) {
                        if (response.success) {
                            renderFolders(response.data.folders);
                            $('#awc-folder-structure').show();
                        } else {
                            alert('<?php esc_html_e('Klasörler yüklenirken bir hata oluştu!', 'advanced-image-management'); ?>');
                        }
                        
                        button.prop('disabled', false);
                    });
                });
                
                // Klasörleri render et
                function renderFolders(folders) {
                    var html = '<ul class="awc-folder-list">';
                    
                    // Yıllara göre sırala
                    folders.sort(function(a, b) {
                        return b.name - a.name; // Yeni yıllar üstte
                    });
                    
                    $.each(folders, function(index, folder) {
                        html += '<li>';
                        html += '<div class="awc-folder-item">';
                        html += '<input type="checkbox" class="awc-folder-checkbox awc-year-checkbox" id="awc-folder-' + folder.name + '" data-path="' + folder.path + '" data-year="' + folder.name + '">';
                        html += '<label for="awc-folder-' + folder.name + '">' + folder.name + ' ' + '<?php esc_html_e('(Yıl)', 'advanced-image-management'); ?>' + '</label>';
                        html += '<span class="awc-folder-info" id="awc-folder-info-' + folder.name + '"></span>';
                        html += '</div>';
                        
                        if (folder.months && folder.months.length > 0) {
                            // Aylara göre sırala
                            folder.months.sort(function(a, b) {
                                return a.name - b.name; // Aylar kronolojik sırada
                            });
                            
                            html += '<ul class="awc-subfolder-list">';
                            
                            $.each(folder.months, function(monthIndex, month) {
                                var monthNames = ['<?php esc_html_e('Ocak', 'advanced-image-management'); ?>', '<?php esc_html_e('Şubat', 'advanced-image-management'); ?>', '<?php esc_html_e('Mart', 'advanced-image-management'); ?>', '<?php esc_html_e('Nisan', 'advanced-image-management'); ?>', '<?php esc_html_e('Mayıs', 'advanced-image-management'); ?>', '<?php esc_html_e('Haziran', 'advanced-image-management'); ?>', '<?php esc_html_e('Temmuz', 'advanced-image-management'); ?>', '<?php esc_html_e('Ağustos', 'advanced-image-management'); ?>', '<?php esc_html_e('Eylül', 'advanced-image-management'); ?>', '<?php esc_html_e('Ekim', 'advanced-image-management'); ?>', '<?php esc_html_e('Kasım', 'advanced-image-management'); ?>', '<?php esc_html_e('Aralık', 'advanced-image-management'); ?>'];
                                var monthName = monthNames[parseInt(month.name) - 1];
                                
                                html += '<li>';
                                html += '<div class="awc-folder-item">';
                                html += '<input type="checkbox" class="awc-folder-checkbox awc-month-checkbox" id="awc-folder-' + folder.name + '-' + month.name + '" data-path="' + month.path + '" data-year="' + folder.name + '" data-month="' + month.name + '">';
                                html += '<label for="awc-folder-' + folder.name + '-' + month.name + '">' + monthName + '</label>';
                                html += '<span class="awc-folder-info" id="awc-folder-info-' + folder.name + '-' + month.name + '"></span>';
                                html += '</div>';
                                html += '</li>';
                            });
                            
                            html += '</ul>';
                        }
                        
                        html += '</li>';
                    });
                    
                    html += '</ul>';
                    
                    $('#awc-folder-tree').html(html);
                    
                    // Yıl checkbox'larına tıklandığında
                    $('.awc-year-checkbox').on('change', function() {
                        var year = $(this).data('year');
                        var checked = $(this).prop('checked');
                        
                        $('.awc-month-checkbox[data-year="' + year + '"]').prop('checked', checked);
                    });
                    
                    // Ay checkbox'larına tıklandığında
                    $('.awc-month-checkbox').on('change', function() {
                        var year = $(this).data('year');
                        var allChecked = $('.awc-month-checkbox[data-year="' + year + '"]:checked').length === $('.awc-month-checkbox[data-year="' + year + '"]').length;
                        
                        $('#awc-folder-' + year).prop('checked', allChecked);
                    });
                }
                
                // Tümünü seç
                $('#awc-select-all-folders').on('click', function() {
                    $('.awc-folder-checkbox').prop('checked', true);
                });
                
                // Tümünü kaldır
                $('#awc-deselect-all-folders').on('click', function() {
                    $('.awc-folder-checkbox').prop('checked', false);
                });
                
                // Seçili klasörleri analiz et
                $('#awc-analyze-selected-folders').on('click', function() {
                    var selectedFolders = [];
                    
                    // Seçilen ay klasörlerini al
                    $('.awc-month-checkbox:checked').each(function() {
                        selectedFolders.push($(this).data('path'));
                    });
                    
                    if (selectedFolders.length === 0) {
                        alert('<?php esc_html_e('Lütfen en az bir klasör seçin!', 'advanced-image-management'); ?>');
                        return;
                    }
                    
                    var button = $(this);
                    button.prop('disabled', true);
                    
                    // Analiz sonuçlarını temizle
                    $('#awc-folder-analysis-results').html('<p><?php esc_html_e('Analiz yapılıyor...', 'advanced-image-management'); ?></p>');
                    $('#awc-folder-analysis').show();
                    
                    // Her klasör için analiz yap
                    var totalImages = 0;
                    var totalSize = 0;
                    var formatCounts = {};
                    var folderResults = {};
                    var processedFolders = 0;
                    
                    function analyzeFolders() {
                        if (processedFolders >= selectedFolders.length) {
                            // Tüm klasörler analiz edildi, sonuçları göster
                            showAnalysisResults();
                            button.prop('disabled', false);
                            return;
                        }
                        
                        var folder = selectedFolders[processedFolders];
                        
                        var data = {
                            action: 'awc_analyze_folder_for_resize',
                            folder: folder,
                            nonce: '<?php echo wp_create_nonce('awc_analyze_folder_for_resize'); ?>'
                        };
                        
                        $.post(ajaxurl, data, function(response) {
                            if (response.success) {
                                // Klasör bilgilerini güncelle
                                var folderInfo = response.data;
                                
                                // Toplam sayıları güncelle
                                totalImages += folderInfo.total_images;
                                totalSize += folderInfo.total_size_bytes;
                                
                                // Format sayılarını güncelle
                                $.each(folderInfo.format_counts, function(format, count) {
                                    if (formatCounts[format]) {
                                        formatCounts[format] += count;
                                    } else {
                                        formatCounts[format] = count;
                                    }
                                });
                                
                                // Klasör sonuçlarını kaydet
                                folderResults[folder] = folderInfo;
                                
                                // Klasör bilgisini göster
                                var folderPath = folder.split('/');
                                var year = folderPath[1];
                                var month = folderPath[2];
                                var infoElement = $('#awc-folder-info-' + year + '-' + month);
                                
                                if (infoElement.length) {
                                    infoElement.html(' - ' + folderInfo.total_images + ' <?php esc_html_e('resim', 'advanced-image-management'); ?>, ' + formatBytes(folderInfo.total_size_bytes));
                                }
                                
                                // Sonraki klasöre geç
                                processedFolders++;
                                analyzeFolders();
                            } else {
                                alert('<?php esc_html_e('Klasör analizi sırasında bir hata oluştu!', 'advanced-image-management'); ?>');
                                button.prop('disabled', false);
                            }
                        }).fail(function() {
                            alert('<?php esc_html_e('Sunucu hatası! İşlem başarısız oldu.', 'advanced-image-management'); ?>');
                            button.prop('disabled', false);
                        });
                    }
                    
                    // Analiz sonuçlarını göster
                    function showAnalysisResults() {
                        var html = '<div class="awc-analysis-summary">';
                        html += '<p><strong><?php esc_html_e('Toplam Resim Sayısı', 'advanced-image-management'); ?>:</strong> ' + totalImages + '</p>';
                        html += '<p><strong><?php esc_html_e('Toplam Boyut', 'advanced-image-management'); ?>:</strong> ' + formatBytes(totalSize) + '</p>';
                        
                        // Format dağılımı
                        html += '<p><strong><?php esc_html_e('Format Dağılımı', 'advanced-image-management'); ?>:</strong></p>';
                        html += '<ul>';
                        
                        $.each(formatCounts, function(format, count) {
                            var percentage = Math.round((count / totalImages) * 100);
                            html += '<li>' + format.toUpperCase() + ': ' + count + ' (' + percentage + '%)</li>';
                        });
                        
                        html += '</ul>';
                        
                        // Klasör detayları
                        html += '<p><strong><?php esc_html_e('Klasör Detayları', 'advanced-image-management'); ?>:</strong></p>';
                        html += '<table class="wp-list-table widefat fixed striped">';
                        html += '<thead><tr><th><?php esc_html_e('Klasör', 'advanced-image-management'); ?></th><th><?php esc_html_e('Resim Sayısı', 'advanced-image-management'); ?></th><th><?php esc_html_e('Boyut', 'advanced-image-management'); ?></th><th><?php esc_html_e('Formatlar', 'advanced-image-management'); ?></th></tr></thead>';
                        html += '<tbody>';
                        
                        $.each(folderResults, function(folder, info) {
                            var folderPath = folder.split('/');
                            var year = folderPath[1];
                            var month = folderPath[2];
                            var monthNames = ['<?php esc_html_e('Ocak', 'advanced-image-management'); ?>', '<?php esc_html_e('Şubat', 'advanced-image-management'); ?>', '<?php esc_html_e('Mart', 'advanced-image-management'); ?>', '<?php esc_html_e('Nisan', 'advanced-image-management'); ?>', '<?php esc_html_e('Mayıs', 'advanced-image-management'); ?>', '<?php esc_html_e('Haziran', 'advanced-image-management'); ?>', '<?php esc_html_e('Temmuz', 'advanced-image-management'); ?>', '<?php esc_html_e('Ağustos', 'advanced-image-management'); ?>', '<?php esc_html_e('Eylül', 'advanced-image-management'); ?>', '<?php esc_html_e('Ekim', 'advanced-image-management'); ?>', '<?php esc_html_e('Kasım', 'advanced-image-management'); ?>', '<?php esc_html_e('Aralık', 'advanced-image-management'); ?>'];
                            var monthName = monthNames[parseInt(month) - 1];
                            
                            var formatInfo = '';
                            $.each(info.format_counts, function(format, count) {
                                formatInfo += format.toUpperCase() + ': ' + count + ' ';
                            });
                            
                            html += '<tr>';
                            html += '<td>' + year + '/' + monthName + '</td>';
                            html += '<td>' + info.total_images + '</td>';
                            html += '<td>' + formatBytes(info.total_size_bytes) + '</td>';
                            html += '<td>' + formatInfo + '</td>';
                            html += '</tr>';
                        });
                        
                        html += '</tbody></table>';
                        html += '</div>';
                        
                        $('#awc-folder-analysis-results').html(html);
                    }
                    
                    // Analizi başlat
                    analyzeFolders();
                });
                
                // Yeniden boyutlandırmayı başlat
                $('#awc-start-resize').on('click', function() {
                    var selectedFolders = [];
                    
                    // Seçilen ay klasörlerini al
                    $('.awc-month-checkbox:checked').each(function() {
                        selectedFolders.push($(this).data('path'));
                    });
                    
                    if (selectedFolders.length === 0) {
                        alert('<?php esc_html_e('Lütfen en az bir klasör seçin!', 'advanced-image-management'); ?>');
                        return;
                    }
                    
                    // Ayarları al
                    var quality = $('#awc-resize-quality').val();
                    var width = $('#awc-resize-width').val();
                    var height = $('#awc-resize-height').val();
                    var keepOriginals = $('#awc-keep-originals').is(':checked');
                    
                    if (width <= 0 && height <= 0) {
                        alert('<?php esc_html_e('Lütfen en az bir boyut değeri girin!', 'advanced-image-management'); ?>');
                        return;
                    }
                    
                    if (confirm('<?php esc_html_e('Bu işlem, seçilen klasörlerdeki resimleri yeniden boyutlandıracaktır. Devam etmek istediğinize emin misiniz?', 'advanced-image-management'); ?>')) {
                        var button = $(this);
                        button.prop('disabled', true);
                        
                        $('#awc-resize-progress').show();
                        $('.awc-progress-bar-inner').css('width', '0%');
                        $('.awc-progress-text').text('0%');
                        $('#awc-resize-current-file').text('<?php esc_html_e('Hazırlanıyor...', 'advanced-image-management'); ?>');
                        $('#awc-resize-count').text('');
                        
                        // İşlemi başlat
                        startResizeProcess(selectedFolders, quality, width, height, keepOriginals);
                    }
                });
                
                // Yeniden boyutlandırma işlemini başlat
                function startResizeProcess(folders, quality, width, height, keepOriginals) {
                    var totalProcessed = 0;
                    var totalSuccess = 0;
                    var totalError = 0;
                    var totalSaved = 0;
                    var currentFolder = 0;
                    
                    // İlk klasörü işle
                    processFolder();
                    
                    // Klasör işleme fonksiyonu
                    function processFolder() {
                        if (currentFolder >= folders.length) {
                            // Tüm klasörler işlendi
                            showResults();
                            return;
                        }
                        
                        var data = {
                            action: 'awc_resize_images_in_folder',
                            folder: folders[currentFolder],
                            quality: quality,
                            width: width,
                            height: height,
                            keep_originals: keepOriginals,
                            nonce: '<?php echo wp_create_nonce('awc_resize_images_in_folder'); ?>'
                        };
                        
                        $.post(ajaxurl, data, function(response) {
                            if (response.success) {
                                totalProcessed += response.data.processed;
                                totalSuccess += response.data.success;
                                totalError += response.data.error;
                                totalSaved += response.data.saved_size;
                                
                                // İlerleme çubuğunu güncelle
                                var progress = Math.round(((currentFolder + 1) / folders.length) * 100);
                                $('.awc-progress-bar-inner').css('width', progress + '%');
                                $('.awc-progress-text').text(progress + '%');
                                $('#awc-resize-current-file').text(folders[currentFolder]);
                                $('#awc-resize-count').text(totalProcessed + ' <?php esc_html_e('resim işlendi', 'advanced-image-management'); ?>');
                                
                                // Sonraki klasöre geç
                                currentFolder++;
                                processFolder();
                            } else {
                                alert('<?php esc_html_e('Resimler yeniden boyutlandırılırken bir hata oluştu!', 'advanced-image-management'); ?>');
                                $('#awc-start-resize').prop('disabled', false);
                            }
                        }).fail(function() {
                            alert('<?php esc_html_e('Sunucu hatası! İşlem başarısız oldu.', 'advanced-image-management'); ?>');
                            $('#awc-start-resize').prop('disabled', false);
                        });
                    }
                    
                    // Sonuçları göster
                    function showResults() {
                        var html = '<div class="awc-success">';
                        html += '<p><strong><?php esc_html_e('İşlem tamamlandı!', 'advanced-image-management'); ?></strong></p>';
                        html += '<p><?php esc_html_e('Toplam İşlenen Resim', 'advanced-image-management'); ?>: ' + totalProcessed + '</p>';
                        html += '<p><?php esc_html_e('Başarılı Boyutlandırma', 'advanced-image-management'); ?>: ' + totalSuccess + '</p>';
                        html += '<p><?php esc_html_e('Hatalı Boyutlandırma', 'advanced-image-management'); ?>: ' + totalError + '</p>';
                        html += '<p><?php esc_html_e('Kazanılan Alan', 'advanced-image-management'); ?>: ' + formatBytes(totalSaved) + '</p>';
                        html += '</div>';
                        
                        $('#awc-resize-summary').html(html);
                        $('#awc-resize-results').show();
                        $('#awc-start-resize').prop('disabled', false);
                    }
                }
                
                // Boyut formatla
                function formatBytes(bytes, decimals = 2) {
                    if (bytes === 0) return '0 Bytes';
                    
                    const k = 1024;
                    const dm = decimals < 0 ? 0 : decimals;
                    const sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
                    
                    const i = Math.floor(Math.log(bytes) / Math.log(k));
                    
                    return parseFloat((bytes / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
                }
            });
        </script>
        
        <style>
            .awc-section {
                margin-bottom: 30px;
                padding: 20px;
                background-color: #fff;
                border: 1px solid #ccc;
                border-radius: 3px;
            }
            
            .awc-success {
                margin-bottom: 20px;
                padding: 10px;
                background-color: #d4f9d4;
                border: 1px solid #a8f9a8;
                border-radius: 3px;
            }
            
            .awc-folder-list {
                margin-left: 0;
                list-style-type: none;
            }
            
            .awc-subfolder-list {
                margin-left: 20px;
                list-style-type: none;
            }
            
            .awc-folder-item {
                margin-bottom: 5px;
                padding: 5px;
                border-radius: 3px;
            }
            
            .awc-folder-item:hover {
                background-color: #f0f0f0;
            }
            
            .awc-folder-info {
                font-size: 12px;
                color: #666;
                margin-left: 5px;
            }
            
            .awc-progress-bar {
                width: 100%;
                height: 20px;
                background-color: #f0f0f0;
                border-radius: 3px;
                margin-top: 10px;
            }
            
            .awc-progress-bar-inner {
                width: 0;
                height: 100%;
                background-color: #0073aa;
                border-radius: 3px;
                transition: width 0.3s;
            }
            
            .awc-progress-text {
                margin-top: 5px;
                font-weight: bold;
                text-align: center;
            }
            
            .awc-progress-info {
                margin-bottom: 5px;
                font-size: 12px;
            }
            
            .awc-analysis-summary {
                margin-top: 15px;
            }
            
            .awc-analysis-summary table {
                width: 100%;
                margin-top: 10px;
            }
        </style>
        <?php
    }
}

// Sayfayı başlat
AWC_Resize_Old_Images_Page::init();
