<?php
/**
 * Admin Menu: Hoş Geldiniz
 * 
 * Bu dosya, Auto WebP Converter eklentisinin Hoş Geldiniz sayfasını içerir.
 */

// Doğrudan erişimi engelle
if (!defined('ABSPATH')) {
    exit;
}

/**
 * Hoş Geldiniz sayfası sınıfı
 */
class AWC_Welcome_Page {
    
    /**
     * Sayfa başlatma
     */
    public static function init() {
        add_action('admin_menu', array(__CLASS__, 'add_menu_page'), 10);
    }
    
    /**
     * Menü sayfasını ekler
     */
    public static function add_menu_page() {
        add_menu_page(
            __('Auto WebP Converter', 'advanced-image-management'),
            __('Auto WebP', 'advanced-image-management'),
            'manage_options',
            'advanced-image-management',
            array(__CLASS__, 'render_page'),
            'dashicons-format-image',
            30
        );
        
        add_submenu_page(
            'advanced-image-management',
            __('Hoş Geldiniz', 'advanced-image-management'),
            __('Hoş Geldiniz', 'advanced-image-management'),
            'manage_options',
            'advanced-image-management',
            array(__CLASS__, 'render_page')
        );
    }
    
    /**
     * Sayfayı render eder
     */
    public static function render_page() {
        ?>
        <div class="wrap">
            <h1><?php esc_html_e('Auto WebP Converter', 'advanced-image-management'); ?></h1>
            
            <div class="awc-welcome-section">
                <h2><?php esc_html_e('Hoş Geldiniz!', 'advanced-image-management'); ?></h2>
                <p><?php esc_html_e('Auto WebP Converter, WordPress sitenizde yüklenen resimleri otomatik olarak WebP formatına dönüştüren ve resim optimizasyonu sağlayan %100 ücretsiz bir eklentidir.', 'advanced-image-management'); ?></p>
                <p><?php esc_html_e('WebP formatı, geleneksel JPEG ve PNG formatlarına göre daha küçük dosya boyutları sağlarken aynı görsel kaliteyi korur. Bu, sitenizin daha hızlı yüklenmesine ve daha az bant genişliği kullanmasına yardımcı olur.', 'advanced-image-management'); ?></p>
            </div>
            
            <div class="awc-welcome-section">
                <h2><?php esc_html_e('Özet İstatistikler', 'advanced-image-management'); ?></h2>
                <div id="awc-statistics-loading">
                    <p><?php esc_html_e('İstatistikler yükleniyor...', 'advanced-image-management'); ?></p>
                </div>
                <div id="awc-statistics-content" style="display: none;">
                    <div class="awc-statistics-grid">
                        <div class="awc-statistics-item">
                            <h3><?php esc_html_e('Toplam Resim', 'advanced-image-management'); ?></h3>
                            <div class="awc-statistics-value" id="awc-total-images">0</div>
                        </div>
                        <div class="awc-statistics-item">
                            <h3><?php esc_html_e('WebP Dönüşümü', 'advanced-image-management'); ?></h3>
                            <div class="awc-statistics-value" id="awc-webp-count">0</div>
                        </div>
                        <div class="awc-statistics-item">
                            <h3><?php esc_html_e('Toplam Boyut', 'advanced-image-management'); ?></h3>
                            <div class="awc-statistics-value" id="awc-total-size">0 MB</div>
                        </div>
                        <div class="awc-statistics-item">
                            <h3><?php esc_html_e('Kazanılan Alan', 'advanced-image-management'); ?></h3>
                            <div class="awc-statistics-value" id="awc-saved-size">0 MB</div>
                        </div>
                    </div>
                    <div class="awc-statistics-chart">
                        <div class="awc-format-distribution">
                            <h3><?php esc_html_e('Format Dağılımı', 'advanced-image-management'); ?></h3>
                            <div id="awc-format-distribution-content"></div>
                        </div>
                        <div class="awc-optimization-rate">
                            <h3><?php esc_html_e('Optimizasyon Oranı', 'advanced-image-management'); ?></h3>
                            <div class="awc-progress-circle">
                                <div class="awc-progress-circle-inner">
                                    <span id="awc-optimization-percentage">0%</span>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            
            <div class="awc-welcome-section">
                <h2><?php esc_html_e('Hızlı Başlangıç', 'advanced-image-management'); ?></h2>
                <div class="awc-quick-start-grid">
                    <div class="awc-quick-start-item">
                        <h3><?php esc_html_e('1. WebP Ayarları', 'advanced-image-management'); ?></h3>
                        <p><?php esc_html_e('WebP dönüştürme ayarlarını yapılandırın ve hosting uyumluluğunu kontrol edin.', 'advanced-image-management'); ?></p>
                        <a href="<?php echo admin_url('admin.php?page=advanced-image-management-webp-settings'); ?>" class="button"><?php esc_html_e('WebP Ayarları', 'advanced-image-management'); ?></a>
                    </div>
                    <div class="awc-quick-start-item">
                        <h3><?php esc_html_e('2. Yükleme Ayarları', 'advanced-image-management'); ?></h3>
                        <p><?php esc_html_e('Resim yükleme ve boyutlandırma ayarlarını yapılandırın.', 'advanced-image-management'); ?></p>
                        <a href="<?php echo admin_url('admin.php?page=advanced-image-management-dimensions'); ?>" class="button"><?php esc_html_e('Yükleme Ayarları', 'advanced-image-management'); ?></a>
                    </div>
                    <div class="awc-quick-start-item">
                        <h3><?php esc_html_e('3. Eski Resimleri Yeniden Boyutlandırma', 'advanced-image-management'); ?></h3>
                        <p><?php esc_html_e('Mevcut resimleri yeniden boyutlandırın ve optimize edin.', 'advanced-image-management'); ?></p>
                        <a href="<?php echo admin_url('admin.php?page=advanced-image-management-resize'); ?>" class="button"><?php esc_html_e('Yeniden Boyutlandırma', 'advanced-image-management'); ?></a>
                    </div>
                    <div class="awc-quick-start-item">
                        <h3><?php esc_html_e('4. Gelişmiş WebP Dönüştürme', 'advanced-image-management'); ?></h3>
                        <p><?php esc_html_e('Mevcut resimleri WebP formatına dönüştürün.', 'advanced-image-management'); ?></p>
                        <a href="<?php echo admin_url('admin.php?page=advanced-image-management-advanced'); ?>" class="button"><?php esc_html_e('Gelişmiş WebP', 'advanced-image-management'); ?></a>
                    </div>
                </div>
            </div>
            
            <div class="awc-welcome-section">
                <h2><?php esc_html_e('Özellikler', 'advanced-image-management'); ?></h2>
                <div class="awc-features-grid">
                    <div class="awc-feature-item">
                        <h3><?php esc_html_e('Otomatik WebP Dönüştürme', 'advanced-image-management'); ?></h3>
                        <p><?php esc_html_e('Yüklenen resimleri otomatik olarak WebP formatına dönüştürür.', 'advanced-image-management'); ?></p>
                    </div>
                    <div class="awc-feature-item">
                        <h3><?php esc_html_e('Resim Boyutlandırma', 'advanced-image-management'); ?></h3>
                        <p><?php esc_html_e('Yüklenen ve mevcut resimleri belirtilen boyutlara göre yeniden boyutlandırır.', 'advanced-image-management'); ?></p>
                    </div>
                    <div class="awc-feature-item">
                        <h3><?php esc_html_e('Kalite Ayarları', 'advanced-image-management'); ?></h3>
                        <p><?php esc_html_e('Hem orijinal resimler hem de WebP dönüşümleri için kalite ayarlarını yapılandırabilirsiniz.', 'advanced-image-management'); ?></p>
                    </div>
                    <div class="awc-feature-item">
                        <h3><?php esc_html_e('Medya Yönetimi', 'advanced-image-management'); ?></h3>
                        <p><?php esc_html_e('Medya kütüphanesindeki resimleri analiz eder ve varyasyonları kategorilere ayırır.', 'advanced-image-management'); ?></p>
                    </div>
                    <div class="awc-feature-item">
                        <h3><?php esc_html_e('Klasör Bazlı İşlem', 'advanced-image-management'); ?></h3>
                        <p><?php esc_html_e('Yıl ve ay bazında klasörleri seçerek işlem yapabilirsiniz.', 'advanced-image-management'); ?></p>
                    </div>
                    <div class="awc-feature-item">
                        <h3><?php esc_html_e('İlerleme Çubukları', 'advanced-image-management'); ?></h3>
                        <p><?php esc_html_e('Tüm işlemlerde ilerleme durumunu görebilirsiniz.', 'advanced-image-management'); ?></p>
                    </div>
                </div>
            </div>
            
            <div class="awc-welcome-section awc-donation-section">
                <h2><?php esc_html_e('Bağış Yapın', 'advanced-image-management'); ?></h2>
                <div class="awc-donation-content">
                    <p><?php esc_html_e('Auto WebP Converter tamamen ücretsiz bir eklentidir ve her zaman ücretsiz kalacaktır. Eğer bu eklentiyi faydalı bulduysanız ve geliştirilmesine katkıda bulunmak isterseniz, aşağıdaki yöntemlerle bağış yapabilirsiniz.', 'advanced-image-management'); ?></p>
                    
                    <div class="awc-donation-methods">
                        <div class="awc-donation-method">
                            <h3><?php esc_html_e('PayPal ile Bağış', 'advanced-image-management'); ?></h3>
                            <p><?php esc_html_e('PayPal üzerinden hızlı ve güvenli bir şekilde bağış yapabilirsiniz.', 'advanced-image-management'); ?></p>
                            <p class="awc-donation-address"><strong>PayPal:</strong> info@arajans.com</p>
                            <a href="https://www.paypal.com/donate/?business=info@arajans.com" target="_blank" class="button button-primary"><?php esc_html_e('PayPal ile Bağış Yap', 'advanced-image-management'); ?></a>
                        </div>
                        
                        <div class="awc-donation-method">
                            <h3><?php esc_html_e('Kripto Para ile Bağış', 'advanced-image-management'); ?></h3>
                            <p><?php esc_html_e('Kripto para birimleri ile bağış yapmak isterseniz, aşağıdaki adresleri kullanabilirsiniz.', 'advanced-image-management'); ?></p>
                            <p class="awc-donation-address"><strong>USDT:</strong> 0x4f6576e24cc6176b9c300097a55e2402692b5cdf</p>
                            <p class="awc-donation-address"><strong>BNB :</strong> 0x4f6576e24cc6176b9c300097a55e2402692b5cdf</p>
                            <p class="awc-donation-address"><strong>Bitcoin:</strong> 1JyuHVjjBjLnCRyYXyeuYyBehBWk6vTM5A</p>
                        </div>
                    </div>
                    
                    <div class="awc-donation-message">
                        <p><?php esc_html_e('Bağışlarınız sayesinde, eklentimizi daha da geliştirmeye, yeni özellikler eklemeye ve daha iyi destek sağlamaya devam edebiliriz. Her türlü desteğiniz için şimdiden teşekkür ederiz!', 'advanced-image-management'); ?></p>
                    </div>
                </div>
            </div>
        </div>
        
        <script>
            jQuery(document).ready(function($) {
                // İstatistikleri yükle
                function loadStatistics() {
                    var data = {
                        action: 'awc_get_overall_statistics',
                        nonce: '<?php echo wp_create_nonce('awc_get_overall_statistics'); ?>'
                    };
                    
                    $.post(ajaxurl, data, function(response) {
                        if (response.success) {
                            var stats = response.data;
                            
                            // İstatistik değerlerini güncelle
                            $('#awc-total-images').text(stats.total_images);
                            $('#awc-webp-count').text(stats.webp_count);
                            $('#awc-total-size').text(stats.total_size_formatted);
                            $('#awc-saved-size').text(stats.saved_size_formatted);
                            
                            // Optimizasyon oranını güncelle
                            $('#awc-optimization-percentage').text(stats.saved_percentage + '%');
                            $('.awc-progress-circle-inner').css('background', 'conic-gradient(#0073aa ' + stats.saved_percentage * 3.6 + 'deg, #f0f0f0 0deg)');
                            
                            // Format dağılımını göster
                            var formatHtml = '<ul class="awc-format-list">';
                            
                            $.each(stats.format_counts, function(format, count) {
                                var percentage = Math.round((count / stats.total_images) * 100);
                                var formatName = format;
                                
                                if (format === 'webp_converted') {
                                    formatName = 'WebP (dönüştürülmüş)';
                                } else {
                                    formatName = format.toUpperCase();
                                }
                                
                                formatHtml += '<li>';
                                formatHtml += '<span class="awc-format-name">' + formatName + '</span>';
                                formatHtml += '<span class="awc-format-bar"><span class="awc-format-bar-inner" style="width: ' + percentage + '%;"></span></span>';
                                formatHtml += '<span class="awc-format-count">' + count + ' (' + percentage + '%)</span>';
                                formatHtml += '</li>';
                            });
                            
                            formatHtml += '</ul>';
                            
                            $('#awc-format-distribution-content').html(formatHtml);
                            
                            // İstatistikleri göster
                            $('#awc-statistics-loading').hide();
                            $('#awc-statistics-content').show();
                        } else {
                            $('#awc-statistics-loading').html('<p><?php esc_html_e('İstatistikler yüklenirken bir hata oluştu!', 'advanced-image-management'); ?></p>');
                        }
                    }).fail(function() {
                        $('#awc-statistics-loading').html('<p><?php esc_html_e('Sunucu hatası! İstatistikler yüklenemedi.', 'advanced-image-management'); ?></p>');
                    });
                }
                
                // İstatistikleri yükle
                loadStatistics();
            });
        </script>
        
        <style>
            .awc-welcome-section {
                margin-bottom: 30px;
                padding: 20px;
                background-color: #fff;
                border: 1px solid #ccc;
                border-radius: 3px;
            }
            
            .awc-statistics-grid {
                display: grid;
                grid-template-columns: repeat(4, 1fr);
                gap: 20px;
                margin-bottom: 20px;
            }
            
            .awc-statistics-item {
                text-align: center;
                padding: 15px;
                background-color: #f9f9f9;
                border-radius: 3px;
            }
            
            .awc-statistics-value {
                font-size: 24px;
                font-weight: bold;
                color: #0073aa;
            }
            
            .awc-statistics-chart {
                display: grid;
                grid-template-columns: 2fr 1fr;
                gap: 20px;
            }
            
            .awc-format-distribution, .awc-optimization-rate {
                padding: 15px;
                background-color: #f9f9f9;
                border-radius: 3px;
            }
            
            .awc-format-list {
                list-style: none;
                margin: 0;
                padding: 0;
            }
            
            .awc-format-list li {
                margin-bottom: 10px;
                display: flex;
                align-items: center;
            }
            
            .awc-format-name {
                width: 150px;
            }
            
            .awc-format-bar {
                flex-grow: 1;
                height: 20px;
                background-color: #f0f0f0;
                border-radius: 3px;
                margin: 0 10px;
                overflow: hidden;
            }
            
            .awc-format-bar-inner {
                height: 100%;
                background-color: #0073aa;
                border-radius: 3px;
            }
            
            .awc-format-count {
                width: 100px;
                text-align: right;
            }
            
            .awc-progress-circle {
                width: 150px;
                height: 150px;
                border-radius: 50%;
                background-color: #f0f0f0;
                margin: 0 auto;
                display: flex;
                align-items: center;
                justify-content: center;
            }
            
            .awc-progress-circle-inner {
                width: 130px;
                height: 130px;
                border-radius: 50%;
                background: conic-gradient(#0073aa 0deg, #f0f0f0 0deg);
                display: flex;
                align-items: center;
                justify-content: center;
                font-size: 24px;
                font-weight: bold;
                color: #0073aa;
                position: relative;
            }
            
            .awc-progress-circle-inner::before {
                content: '';
                position: absolute;
                width: 110px;
                height: 110px;
                border-radius: 50%;
                background-color: #fff;
            }
            
            .awc-progress-circle-inner span {
                position: relative;
                z-index: 1;
            }
            
            .awc-quick-start-grid {
                display: grid;
                grid-template-columns: repeat(4, 1fr);
                gap: 20px;
            }
            
            .awc-quick-start-item {
                padding: 15px;
                background-color: #f9f9f9;
                border-radius: 3px;
                text-align: center;
            }
            
            .awc-features-grid {
                display: grid;
                grid-template-columns: repeat(3, 1fr);
                gap: 20px;
            }
            
            .awc-feature-item {
                padding: 15px;
                background-color: #f9f9f9;
                border-radius: 3px;
            }
            
            /* Bağış bölümü stilleri */
            .awc-donation-section {
                background-color: #f7fcff;
                border-color: #0073aa;
            }
            
            .awc-donation-section h2 {
                color: #0073aa;
            }
            
            .awc-donation-methods {
                display: grid;
                grid-template-columns: repeat(2, 1fr);
                gap: 20px;
                margin: 20px 0;
            }
            
            .awc-donation-method {
                padding: 20px;
                background-color: #fff;
                border: 1px solid #e0e0e0;
                border-radius: 3px;
                text-align: center;
            }
            
            .awc-donation-address {
                background-color: #f9f9f9;
                padding: 10px;
                border-radius: 3px;
                margin: 10px 0;
                word-break: break-all;
            }
            
            .awc-donation-message {
                margin-top: 20px;
                padding: 15px;
                background-color: #f0f7fb;
                border-left: 4px solid #0073aa;
                font-style: italic;
            }
            
            @media screen and (max-width: 1200px) {
                .awc-statistics-grid {
                    grid-template-columns: repeat(2, 1fr);
                }
                
                .awc-quick-start-grid {
                    grid-template-columns: repeat(2, 1fr);
                }
                
                .awc-features-grid {
                    grid-template-columns: repeat(2, 1fr);
                }
                
                .awc-donation-methods {
                    grid-template-columns: 1fr;
                }
            }
            
            @media screen and (max-width: 782px) {
                .awc-statistics-chart {
                    grid-template-columns: 1fr;
                }
                
                .awc-quick-start-grid {
                    grid-template-columns: 1fr;
                }
                
                .awc-features-grid {
                    grid-template-columns: 1fr;
                }
            }
        </style>
        <?php
    }
}

// Sayfayı başlat
AWC_Welcome_Page::init();
