/* Auto WebP Converter Admin JavaScript */

jQuery(document).ready(function($) {
    // Varyasyon kategorilerini açıp kapatma
    $(document).on('click', '.awc-variation-header', function(e) {
        // Checkbox'a tıklandıysa, toggle işlemini engelle
        if ($(e.target).is('input[type="checkbox"]')) {
            return;
        }
        
        var $files = $(this).next('.awc-variation-files');
        $files.slideToggle(200);
    });
    
    // Kategori checkbox'larına tıklandığında alt öğeleri de seç/kaldır
    $(document).on('change', '.awc-variation-category-checkbox', function() {
        var category = $(this).data('category');
        var checked = $(this).prop('checked');
        
        $('.awc-variation-file-checkbox[data-category="' + category + '"]').prop('checked', checked);
    });
    
    // Alt öğelerin durumuna göre kategori checkbox'ını güncelle
    $(document).on('change', '.awc-variation-file-checkbox', function() {
        var category = $(this).data('category');
        var allChecked = $('.awc-variation-file-checkbox[data-category="' + category + '"]:checked').length;
        var totalFiles = $('.awc-variation-file-checkbox[data-category="' + category + '"]').length;
        
        if (allChecked === totalFiles) {
            $('.awc-variation-category-checkbox[data-category="' + category + '"]').prop('checked', true);
        } else {
            $('.awc-variation-category-checkbox[data-category="' + category + '"]').prop('checked', false);
        }
    });
    
    // Hata durumunda ilerleme çubuğunu sıfırla
    $(document).ajaxError(function(event, jqxhr, settings, thrownError) {
        if (settings.url.indexOf('admin-ajax.php') !== -1) {
            $('.awc-progress-bar-inner').css('width', '0%');
            $('.awc-progress-text').text('0%');
            
            // Butonları etkinleştir
            $('button').prop('disabled', false);
            
            // Hata mesajı göster
            alert('İşlem sırasında bir hata oluştu: ' + thrownError);
        }
    });
    
    // Boyut formatla (KB, MB, GB)
    window.formatBytes = function(bytes, decimals = 2) {
        if (bytes === 0) return '0 Bytes';
        
        const k = 1024;
        const dm = decimals < 0 ? 0 : decimals;
        const sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
        
        const i = Math.floor(Math.log(bytes) / Math.log(k));
        
        return parseFloat((bytes / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
    };
});
